<?php
namespace Ecommerce\Services;

use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use \Teknisa\Libs\Util\Utilities as LibUtilities;

class AutorizacaoFornecimentoService {
    
    protected $entityManager;
    protected $environment;
    protected $crudService;
    protected $utilities;

    public function __construct(EntityManager $entityManager, $environment, $crudService,LibUtilities $utilities)
    {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
        $this->crudService = $crudService;
        $this->utilities = $utilities;
    }
    
    public function iniciaTransacao(){
        $this->entityManager->beginTransaction();
    }

    public function commit(){
        $this->entityManager->commit();
    }

    public function flush(){
        $this->entityManager->flush();
    }

    public function rollback(){
        $this->entityManager->rollback();
    }
    
    public function retornaAfsPlanilhaAlteracao($row)
    {
        $query = "SELECT 
                       AF.NRAUTOFORN AF_NUMERO_DA_AF,
                       AF.CDFILDEST AF_UNIDADE_DESTINO,
                       FI.NMFILIAL AF_NOME_DA_UNIDADE_DESTINO,
                       FN.SGESTADO AF_ESTADO_DO_FORNECEDOR,
                       FI.DSEMAILFILI AF_EMAIL_UNIDADE,
                       FN.NRINSJURFORN AF_FORNECEDOR,
                       FN.NMFANTFORN AF_NOME_FANTASIA_DO_FORNECEDOR,
                       ITEMAUTF.DTPROGENTAF AF_DATA_DE_ENTREGA,
                       PGE.TXMSGFORNECEDOR AF_CBC,
                       'Para os produtos que não constam neste relatório, favor manter conforme está na AF (Autorização de Fornecimento).' AF_OBSERVACAO,
                       PRODUTO.CDARVPROD ITEM_PRODUTO,
                       PRODUTO.NMPRODUTO ITEM_NOME_DO_PRODUTO,
                       PRODUTO.SGUNIDADE ITEM_UN,
                       MARCA.NMMARCA ITEM_MARCA,
                       (CASE WHEN ITEMAUTF.DTPROGENTAF <> DTPROGENTAFANT THEN DTPROGENTAFANT END) ITEM_ENTREGA_DE,
                       (CASE WHEN ITEMAUTF.DTPROGENTAF <> DTPROGENTAFANT THEN ITEMAUTF.DTPROGENTAF END) ITEM_ENTREGA_PARA,
                       (CASE WHEN ITEMAUTF.QTPROGENTAF <> ITEMAUTF.QTNOVAPROGAF THEN NVL(ITEMAUTF.QTPROGENTAF, 0) END) ITEM_QUANTIDADE_DE,
                       (CASE WHEN ITEMAUTF.QTPROGENTAF <> ITEMAUTF.QTNOVAPROGAF THEN NVL(ITEMAUTF.QTNOVAPROGAF, 0) END) ITEM_QUANTIDADE_PARA,
                       ITEMAUTF.DSJUSTITMAF ITEM_JUSTIFICATIVA
                  FROM AUTOFORNE AF,
                       PRODUTO,
                       MARCA,
                       FILIAL FD,
                       PARAMGERALECOMMERCE PGE,
                       (SELECT I.DTPROGENTAFDEP DTPROGENTAF, I.QTPROGENTDEP  QTNOVAPROGAF, I.CDPRODUTO, 
                               I.QTPROGENTANT QTPROGENTAF, I.DSJUSTITMAF, I.CDFILDEST, I.CDFILLANC, 
                               I.NRAUTOFORN, I.CDMARCA, I.DTPROGENTAFANT 
                          FROM LOGPLANITEMAF I
                         WHERE INSTR(:L_NRLOGPLANITEMAF, NRLOGPLANITEMAF) <> 0 
                        UNION
                        SELECT I.DTPROGENTAF, I.QTPROGENTAF  QTNOVAPROGAF, I.CDPRODUTO, I.QTPROGENTAF QTPROGENTAF,
                               I.DSJUSTITMAF, I.CDFILDEST, I.CDFILLANC, I.NRAUTOFORN, I.CDMARCA, I.DTPROGENTAF DTPROGENTAFANT 
                          FROM ITEMAUTF I
                         WHERE :L_NRLOGPLANITEMAF IS NULL) ITEMAUTF,
                       (SELECT FILIAL.CDFILIAL, FILIAL.NMFILIAL, ENDEFILI.DSEMAILFILI 
                          FROM FILIAL, ENDEFILI
                         WHERE FILIAL.CDFILIAL = ENDEFILI.CDFILIAL 
                           AND ENDEFILI.IDTPENDEFILI = 'P') FI, 
                       (SELECT F.CDFORNECED, F.IDTPIJURFORN, F.NRINSJURFORN, F.NMRAZSOCFORN, F.NMFANTFORN,
                               E.DSENDEFORN, E.NMCONTFORN, E.NRTELEFORN, F.DSEMAILCOT, E.SGESTADO
                          FROM FORNECEDOR F, ENDEFORN E
                         WHERE (F.CDFORNECED = E.CDFORNECED) AND
                               (E.IDTPENDEFORN = 'P') AND
                               (F.CDFORNECED = :P_CDFORNECED)) FN
                 WHERE (INSTR(:L_CDFILDEST, AF.CDFILDEST) <> 0) AND
                       (INSTR(:L_NRAUTOFORN, AF.NRAUTOFORN) <> 0) AND
                       (INSTR(:L_NRSEQAPURAF, AF.NRSEQAPURAF) <> 0) AND
                       (INSTR(:L_CDFILLANC, AF.CDFILLANC) <> 0) AND
                       (INSTR(:L_NRSEQENVIOAFORN, AF.NRSEQENVIOAFORN) <> 0) AND
                       (FD.CDFILCENTCMP = PGE.CDFILIAL(+)) AND 
                       (AF.CDFILDEST = FD.CDFILIAL) AND 
                       (AF.CDFILDEST = FI.CDFILIAL) AND 
                       (AF.CDFILDEST = ITEMAUTF.CDFILDEST) AND
                       (AF.CDFILLANC = ITEMAUTF.CDFILLANC) AND
                       (AF.NRAUTOFORN = ITEMAUTF.NRAUTOFORN) AND
                       (ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO)AND
                       (ITEMAUTF.CDMARCA = MARCA.CDMARCA) AND
                       (AF.CDFORNECED = FN.CDFORNECED) AND
                       (AF.IDSITUATUAAF IS NULL) AND
                       (AF.IDAFFORALIM = 'N') AND
                       (NVL(AF.IDAFOPERLOG, '2') = '2')          
                ORDER BY 
                      AF.CDFORNECED,
                      AF.NRAUTOFORN,
                      AF.CDFILDEST,
                      AF.CDFILLANC,
                      ITEMAUTF.DTPROGENTAF,
                      PRODUTO.CDARVPROD";
                    
        $params = array(
            "P_CDFORNECED" => $row['CDFORNECED'],
            "L_NRLOGPLANITEMAF" => $row['NRLOGPLANITEMAF'],
            "L_CDFILDEST" => $row['CDFILDEST'],
            "L_NRAUTOFORN" => $row['NRAUTOFORN'],
            "L_NRSEQAPURAF" => $row['NRSEQAPURAF'],
            "L_CDFILLANC" => $row['CDFILLANC'],
            "L_NRSEQENVIOAFORN" => $row['NRSEQENVIOAFORN']
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);

            return $std->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function retornaAfsLidas($row)
    {
        $query = "SELECT DISTINCT 
                       A.NRSEQENVIOAFORN, E.IDTIPENVLIDO
                    FROM FORNECEDOR FO,
                     AUTOFORNE A,
                     FILIAL F,
                     ENVIOAFFORN E
                    WHERE ((FO.CDFORNECED = :P_CDFORNECED 
                              AND FO.CDFORNECED = A.CDFORNECED 
                              AND FO.NRORG = A.NRORG) 
                           OR 
                           (FO.CDFORNERELACAF = :P_CDFORNECED
                            AND FO.CDFORNECED = A.CDFORNECED
                            AND FO.NRORG = A.NRORG))
                    AND (INSTR(:L_CDFILDEST, A.CDFILDEST) <> 0 OR :L_CDFILDEST = 'T')
                    AND (INSTR(:L_NRAUTOFORN, A.NRAUTOFORN) <> 0 OR :L_NRAUTOFORN = 'T')
                    AND (INSTR(:L_NRSEQAPURAF, A.NRSEQAPURAF) <> 0)
                    AND (INSTR(:L_NRSEQENVIOAFORN, A.NRSEQENVIOAFORN) <> 0)
                    AND (INSTR(:L_CDFILLANC, A.CDFILLANC) <> 0)
                    AND A.CDFILDEST = F.CDFILIAL
                    AND E.NRSEQENVIOAFORN = A.NRSEQENVIOAFORN
                    AND E.CDFORNECED = A.CDFORNECED
                    AND A.NRSEQENVIOAFORN NOT IN (SELECT DISTINCT
                                                   A.NRSEQENVIOAFORN
                                                FROM FORNECEDOR FO,
                                                 AUTOFORNE A,
                                                 LOGDOWNLOADAF L,
                                                 FILIAL F
                                                WHERE ((FO.CDFORNECED = :P_CDFORNECED 
                                                          AND FO.CDFORNECED = A.CDFORNECED 
                                                          AND FO.NRORG = A.NRORG) 
                                                       OR 
                                                       (FO.CDFORNERELACAF = :P_CDFORNECED
                                                        AND FO.CDFORNECED = A.CDFORNECED
                                                        AND FO.NRORG = A.NRORG))
                                                AND (INSTR(:L_NRSEQAPURAF, A.NRSEQAPURAF) <> 0)
                                                AND (INSTR(:L_NRSEQENVIOAFORN, A.NRSEQENVIOAFORN) <> 0)
                                                AND (INSTR(:L_CDFILLANC, A.CDFILLANC) <> 0)
                                                AND A.NRSEQENVIOAFORN = L.NRSEQENVIOAFORN (+)
                                                AND A.CDFORNECED = L.CDFORNECED (+)
                                                AND A.NRAUTOFORN = L.NRAUTOFORN (+)
                                                AND A.CDFILDEST = L.CDFILDEST (+)
                                                AND A.CDFILLANC = L.CDFILLANC (+)
                                                AND A.CDFILDEST = F.CDFILIAL
                                                AND L.NRSEQENVIOAFORN IS NULL)";
                    
        $params = array(
            "P_CDFORNECED"      => $row['CDFORNECED'],
            "L_CDFILDEST"       => $row['CDFILDEST'],
            "L_NRAUTOFORN"      => $row['NRAUTOFORN'],
            "L_NRSEQAPURAF"     => $row['NRSEQAPURAF'],
            "L_NRSEQENVIOAFORN" => $row['NRSEQENVIOAFORN'],
            "L_CDFILLANC"       => $row['CDFILLANC']
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);

            return $std->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function retornaEmailComprador($loteStatusAlterado, $cdforneced)
    {
        $query = "SELECT DISTINCT OPERADOR.DSEMAILOPER, AUTOFORNE.NRSEQENVIOAFORN, AUTOFORNE.NRSEQAPURAF
                      FROM AUTOFORNE, OPERADOR
                     WHERE (INSTR(:L_NRSEQENVIOAFORN, AUTOFORNE.NRSEQENVIOAFORN) <> 0)
                       AND (INSTR(:P_CDFORNECED, AUTOFORNE.CDFORNECED) <> 0)
                       AND NVL(AUTOFORNE.CDOPERLANCAF, AUTOFORNE.CDOPERADOR) = OPERADOR.CDOPERADOR
                       AND OPERADOR.DSEMAILOPER IS NOT NULL
                    ORDER BY OPERADOR.DSEMAILOPER, AUTOFORNE.NRSEQENVIOAFORN";
                    
        $params = array(
            "L_NRSEQENVIOAFORN" => $loteStatusAlterado,
            "P_CDFORNECED"      => $cdforneced
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);

            return $std->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function insereLogdownloadaf($nrseqdownloadaf, $nrseqenvioaforn, $cdforneced, $nrautoforn, $cdfildest, $cdfillanc, $dslogineco)
    {
        $query = "INSERT INTO LOGDOWNLOADAF
                  (NRSEQDOWNLOADAF, NRSEQENVIOAFORN, CDFORNECED, NRAUTOFORN, CDFILDEST, CDFILLANC, DSLOGINECO, DTDOWNLOAD, NRORG)
                  VALUES (:NRSEQDOWNLOADAF, :NRSEQENVIOAFORN, :CDFORNECED, :NRAUTOFORN, :CDFILDEST, :CDFILLANC, :DSLOGINECO, SYSDATE, :NRORG)";
                    
        $params = array(
            "NRSEQDOWNLOADAF" => $nrseqdownloadaf,
            "NRSEQENVIOAFORN" => $nrseqenvioaforn,
            "CDFORNECED"      => $cdforneced,
            "NRAUTOFORN"      => $nrautoforn,
            "CDFILDEST"       => $cdfildest,
            "CDFILLANC"       => $cdfillanc,
            "DSLOGINECO"      => $dslogineco,
            "NRORG"           => $this->environment->getNrorgTrab()
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function atualizaStatusLoteAf($nrseqenvioaforn, $cdforneced)
    {
        $query = "UPDATE ENVIOAFFORN
                     SET IDTIPENVLIDO = 'S',
                         DTRECEBEENVAF = SYSDATE
                   WHERE NRSEQENVIOAFORN = :NRSEQENVIOAFORN
                     AND CDFORNECED = :CDFORNECED";
                    
        $params = array(
            "NRSEQENVIOAFORN" => $nrseqenvioaforn,
            "CDFORNECED"      => $cdforneced
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getLabels ($row)
    {
        $query = "  SELECT
                        DSETIQUETA,
                        NRETIQUETA
                    FROM
                        ETIQUETAECOMMERCE
                    WHERE
                        CDFORNECED = :P_CDFORNECED AND
                        CDOPERADOR = :P_CDOPERADOR AND
                        NRORG = :P_NRORG
                    ORDER BY
                        DSETIQUETA";
        
        $params = array(
            "P_CDFORNECED" => $row['P_CDFORNECED'],
            "P_CDOPERADOR" => $row['P_CDOPERADOR'],
            "P_NRORG"      => $row['P_NRORG']
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);

            return $std->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function checkLabelExist ($row)
    {
        $query = "  SELECT 
                        * 
                    FROM 
                        ETIQUETAECOMMERCE
                    WHERE
                        CDFORNECED = :P_CDFORNECED AND
                        CDOPERADOR = :P_CDOPERADOR AND
                        NRORG = :P_NRORG AND
                        UPPER(DSETIQUETA) LIKE UPPER(:P_DSETIQUETA)";
        
        $params = array(
            "P_CDFORNECED" => $row['P_CDFORNECED'],
            "P_CDOPERADOR" => $row['P_CDOPERADOR'],
            "P_NRORG"      => $row['P_NRORG'],
            "P_DSETIQUETA" => $row['P_DSETIQUETA']
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);

            return $std->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function saveLabel($row, $newCode)
    {
        $query = "  INSERT INTO 
                        ETIQUETAECOMMERCE
                        (
                            CDFORNECED, CDOPERADOR, DSETIQUETA, NRETIQUETA, NRORG
                        )
                        VALUES 
                        (
                            :P_CDFORNECED, :P_CDOPERADOR, :P_DSETIQUETA, :P_NRETIQUETA, :P_NRORG
                        )";
                    
        $params = array(
            "P_CDFORNECED" => $row['P_CDFORNECED'],
            "P_CDOPERADOR" => $row['P_CDOPERADOR'],
            "P_DSETIQUETA" => $row['P_DSETIQUETA'],
            "P_NRETIQUETA" => $newCode,
            "P_NRORG"      => $row['P_NRORG']
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function unbindLabels($row)
    {
        $this->iniciaTransacao();
        
        $query = "  DELETE FROM 
                        ETIQUETAAF
                    WHERE 
                        INSTR(:P_NRAUTOFORN, NRAUTOFORN) > 0 AND
                        CDOPERADOR = :P_CDOPERADOR";
                    
        $params = array(
            "P_NRAUTOFORN" => $row['P_NRAUTOFORN'],
            "P_CDOPERADOR" => $row['P_CDOPERADOR']
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
            $this->commit();
        } catch (\Exception $e) {
            $this->rollback();
            throw $e;
        }
    }
    
    public function bindLabelsAF($row)
    {
        $this->iniciaTransacao();
        
        $arrayAutoForn = explode('_', $row['P_NRAUTOFORN']);
        
        foreach ($arrayAutoForn as $autoForn) {
            $query = "  INSERT INTO
                            ETIQUETAAF
                            (
                                CDOPERADOR, NRETIQUETA, NRAUTOFORN
                            )
                            VALUES 
                            (
                                :P_CDOPERADOR, :P_NRETIQUETA, :P_NRAUTOFORN
                            )";
                    
            $params = array(
                "P_CDOPERADOR" => $row['P_CDOPERADOR'],
                "P_NRETIQUETA" => $row['P_NRETIQUETA'],
                "P_NRAUTOFORN" => $autoForn
            );
            
            try {
                $std = $this->connection->prepare($query);
                $std->execute($params);
            } catch (\Exception $e) {
                $this->rollback();
                throw $e;
            }
        }
        
        $this->commit();
    }
    
    public function deleteLabel($row)
    {
        $this->iniciaTransacao();
        
        $query = "  DELETE FROM
                        ETIQUETAECOMMERCE
                    WHERE 
                        NRETIQUETA = :P_NRETIQUETA";
                    
        $params = array(
            "P_NRETIQUETA" => $row['P_NRETIQUETA']
        );
        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
            $this->commit();
        } catch (\Exception $e) {
            $this->rollback();
            throw $e;
        }
    }
    
    public function retornaParamAtendEmailResponsavel($cdForneced)
    {
        $query = "SELECT DSEMAILNOTIFATENDAF, IDUTLCONFIMATENDAF FROM FORNECEDOR WHERE CDFORNECED = :CDFORNECED";
        $params = array(
            "CDFORNECED" => $cdForneced
        );
        
        $std = $this->connection->prepare($query);
        $std->execute($params);
        return $std->fetchAll()[0];
    }
    
    public function selectProdIdSituAtendimentoItm($selectedRow)
    {
        $query = "SELECT I.NRAUTOFORN, P.CDARVPROD, P.NMPRODUTO, I.CDMARCA, M.NMMARCA FROM ITEMAUTF I, PRODUTO P, MARCA M WHERE CDFILDEST =:CDFILDEST AND CDFILLANC =:CDFILLANC AND NRAUTOFORN =:NRAUTOFORN AND IDSITUATENDIMENTOITM = 'R' AND I.CDPRODUTO = P.CDPRODUTO AND I.CDMARCA = M.CDMARCA";
        $params = array(
            "CDFILDEST"       => $selectedRow['CDFILDEST'],
            "CDFILLANC"       => $selectedRow['CDFILLANC'],
            "NRAUTOFORN"      => $selectedRow['NRAUTOFORN']
        );
        
        $std = $this->connection->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function updateConfirmaAF($selectedRow)
    {
        $query = "UPDATE ITEMAUTF SET IDSITUATENDIMENTOITM = 'C' WHERE CDFILDEST = :CDFILDEST AND CDFILLANC = :CDFILLANC AND NRAUTOFORN = :NRAUTOFORN AND (IDSITUATENDIMENTOITM <> 'R' OR IDSITUATENDIMENTOITM IS NULL)";
        $query2 = "UPDATE AUTOFORNE SET DTCONFATENDIMENTOAF = SYSDATE, IDSITUATENDIMENTOAF = :IDSITUATENDIMENTOAF WHERE CDFILDEST = :CDFILDEST AND CDFILLANC = :CDFILLANC AND NRAUTOFORN = :NRAUTOFORN";
        
        if ($selectedRow['IDSITUATENDIMENTOAF'] != 'R' && $selectedRow['IDSITUATENDIMENTOAF'] != 'C' && $selectedRow['IDSITUATENDIMENTOAF'] != 'P') {
            $params = array(
                "CDFILDEST"       => $selectedRow['CDFILDEST'],
                "CDFILLANC"       => $selectedRow['CDFILLANC'],
                "NRAUTOFORN"      => $selectedRow['NRAUTOFORN']
            );
            
            $std = $this->connection->prepare($query);
            $std->execute($params);
            $statusRecusa = $this->selectProdIdSituAtendimentoItm($selectedRow);
            $status = empty($statusRecusa) ? 'C' : 'P';
            $params2 = array(
                "IDSITUATENDIMENTOAF" => $status,
                "CDFILDEST"           => $selectedRow['CDFILDEST'],
                "CDFILLANC"           => $selectedRow['CDFILLANC'],
                "NRAUTOFORN"          => $selectedRow['NRAUTOFORN']
            );
            $std2 = $this->connection->prepare($query2);
            $std2->execute($params2);
            return $statusRecusa;
        }

    }
    
    public function updateRecusaAF($row)
    {
        try {
            $query = "UPDATE AUTOFORNE SET TXJUSTIFICRECAF = :TXJUSTIFICRECAF, IDSITUATENDIMENTOAF = 'R' WHERE CDFILDEST = :CDFILDEST AND CDFILLANC = :CDFILLANC AND NRAUTOFORN = :NRAUTOFORN";
            $query2 = "UPDATE ITEMAUTF SET TXJUSTIFICRECITM = :TXJUSTIFICRECAF, IDSITUATENDIMENTOITM = 'R' WHERE CDFILDEST = :CDFILDEST AND CDFILLANC = :CDFILLANC AND NRAUTOFORN = :NRAUTOFORN";
            
            foreach ($row['SELECTEDROWS'] as $selectedRow) {     
                if ($selectedRow['IDSITUATENDIMENTOAF'] != 'R' && $selectedRow['IDSITUATENDIMENTOAF'] != 'C' && $selectedRow['IDSITUATENDIMENTOAF'] != 'P') {
                    $params = array(
                        "TXJUSTIFICRECAF" => $row['TXJUSTIFICATIVA'],
                        "CDFILDEST"       => $selectedRow['CDFILDEST'],
                        "CDFILLANC"       => $selectedRow['CDFILLANC'],
                        "NRAUTOFORN"      => $selectedRow['NRAUTOFORN']
                    );
                    
                    $std = $this->connection->prepare($query);
                    $std->execute($params);
                    $std2 = $this->connection->prepare($query2);
                    $std2->execute($params);
                }
            }
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        }

    }
    
    public function updateRecusaProduto($row)
    {
        $rowDadosAF = $row['ROWDADOSAF'];
        $query = "UPDATE ITEMAUTF SET TXJUSTIFICRECITM  = :TXJUSTIFICRECITM, IDSITUATENDIMENTOITM = 'R' WHERE CDFILDEST = :CDFILDEST AND CDFILLANC = :CDFILLANC AND NRAUTOFORN = :NRAUTOFORN AND CDMARCA = :CDMARCA AND CDPRODUTO = :CDPRODUTO";
        foreach($row['SELECTEDROWS'] as $selectedRow){
            $params = array(
                "TXJUSTIFICRECITM" => $row['TXJUSTIFICATIVA'],
                "CDFILDEST"        => $rowDadosAF['CDFILDEST'],
                "CDFILLANC"        => $rowDadosAF['CDFILLANC'],
                "NRAUTOFORN"       => $rowDadosAF['NRAUTOFORN'],
                "CDMARCA"          => $selectedRow['CDMARCA'],
                "CDPRODUTO"        => $selectedRow['CDPRODUTO']
            );
            
            $std = $this->connection->prepare($query);
            $std->execute($params);
        }
    }
    
    public function updateRecusaItens($row)
    {
        $query = "UPDATE ITEMAUTF SET TXJUSTIFICRECITM  = :TXJUSTIFICRECITM, IDSITUATENDIMENTOITM = 'R' WHERE CDFILDEST = :CDFILDEST AND CDFILLANC = :CDFILLANC AND NRAUTOFORN = :NRAUTOFORN AND CDMARCA = :CDMARCA AND CDPRODUTO = :CDPRODUTO";
        foreach($row['SELECTEDROWS'] as $selectedRow){
            $params = array(
                "TXJUSTIFICRECITM" => $row['TXJUSTIFICATIVA'],
                "CDFILDEST"        => $selectedRow['CDFILDEST'],
                "CDFILLANC"        => $selectedRow['CDFILLANC'],
                "NRAUTOFORN"       => $selectedRow['NRAUTOFORN'],
                "CDMARCA"          => $selectedRow['CDMARCA'],
                "CDPRODUTO"        => $selectedRow['CDPRODUTO']
            );
            
            $std = $this->connection->prepare($query);
            $std->execute($params);
        }
    }
    
    public function updateConfirmaItens($row)
    {
        $query = "UPDATE ITEMAUTF SET IDSITUATENDIMENTOITM = 'C' WHERE CDFILDEST =:CDFILDEST AND CDFILLANC =:CDFILLANC AND NRAUTOFORN =:NRAUTOFORN AND CDMARCA =:CDMARCA AND CDPRODUTO =:CDPRODUTO";
        foreach($row['SELECTEDROWS'] as $selectedRow) {
            $params = array(
                "CDFILDEST"        => $selectedRow['CDFILDEST'],
                "CDFILLANC"        => $selectedRow['CDFILLANC'],
                "NRAUTOFORN"       => $selectedRow['NRAUTOFORN'],
                "CDMARCA"          => $selectedRow['CDMARCA'],
                "CDPRODUTO"        => $selectedRow['CDPRODUTO']
            );
            
            $std = $this->connection->prepare($query);
            $std->execute($params);
        }
    }
    
    
    public function validatePassword($operador, $password) 
    {
		$dataSourceName = 'operador';
		
		$conditions = array(
			array(
				'columnName' => 'CDOPERADOR',
				'operator' => '=',
				"value" => $operador
			)
		);
		
		$dataSet = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
		
		if (md5($password) != $dataSet[0]['CDSENHAOPERWEB']) {
			return array("MESSAGE" => "errorAuthOperator", "STATUS" => "error", "ERROR" => true);
		} else {
		    return array("MESSAGE" => "successAuthOperator", "STATUS" => "success", "ERROR" => false);
		}
	}
	
	public function findCdOperator($email) {
		$dataSourceName = 'operador';
		$conditions = array(
			array(
				'columnName' => 'DSEMAILOPER',
				'operator' => 'LIKE',
				'value' => $email
			)
		);
		$dataSet = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
		if(empty($dataSet)){
			throw new \Exception("Operador não cadastrado", 1);
		} else {
			return $dataSet[0]['CDOPERADOR'];
		}
	}
	
    public function saveCollectedData($row){
        try {
            if(is_array($row['CDFILIAL'])){
                foreach($row['CDFILIAL'] as $collection_id){
                    $this->utilities->saveCollectedData($collection_id,$row['OPERATION_ID']);
                }
            }
            else {
                $this->utilities->saveCollectedData($row['CDFILIAL'],$row['OPERATION_ID']);
            }
        } catch (\Exception $e){
            throw $e;
        }
    }
}